#include "main.h"
#include <QDebug>

CMyApplication::CMyApplication(int& argc, char** argv) :
    QCoreApplication(argc, argv), m_SampleCounter(0)
{
    this->m_Timer.setInterval(1);
    this->connect(&this->m_Timer, SIGNAL(timeout()), this, SLOT(generate_crs_and_emit()));
    this->m_Timer.start();
}

void CMyApplication::generate_crs_and_emit()
{
    this->m_SampleCounter++;
    CRS* sample(new CRS(this->m_SampleCounter));
    
    this->m_CRSQueue.enqueue(sample);
    while (this->m_CRSQueue.size() > 300) {
        CRS* x(this->m_CRSQueue.dequeue());
        delete x;
    }
}

void CMyApplication::onSampleCompleted()
{
    CRS* s = (CRS*)this->sender();
    qDebug() << "received sample_completed for sample" << s->m_Id;
}

CRS::CRS(unsigned sample_id) : m_Id(sample_id)
{
    CMyApplication* app = (CMyApplication*)QCoreApplication::instance();
    this->connect(this, SIGNAL(sampleCompleted()), app, SLOT(onSampleCompleted()));
    int n_receivers(this->receivers(SIGNAL(sampleCompleted())));
    qDebug() << "Receivers for sample" << m_Id << ":" << n_receivers;
    Q_ASSERT(n_receivers == 1);
    qDebug() << "emit sample_completed for sample" << this->m_Id;
    emit this->sampleCompleted();
}

int main(int argc, char* argv[])
{
    CMyApplication app(argc, argv);
    return app.exec();
}
